// $Header: /home/ram/u0/vern/bro/RCS/NetVar.h,v 1.43 2001/09/05 04:22:13 vern Exp $
//
// Copyright (c) 1996-1999
//      The Regents of the University of California.  All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that: (1) source code distributions
// retain the above copyright notice and this paragraph in its entirety, (2)
// distributions including binary code include the above copyright notice and
// this paragraph in its entirety in the documentation or other materials
// provided with the distribution, and (3) all advertising materials mentioning
// features or use of this software display the following acknowledgement:
// ``This product includes software developed by the University of California,
// Lawrence Berkeley Laboratory and its contributors.'' Neither the name of
// the University nor the names of its contributors may be used to endorse
// or promote products derived from this software without specific prior
// written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
// WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

#ifndef netvar_h
#define netvar_h

#include "Val.h"

class Func;

extern RecordType* conn_id;
extern RecordType* endpoint;
extern RecordType* endpoint_stats;
extern RecordType* connection_type;
extern RecordType* icmp_conn;
extern RecordType* icmp_context;

extern Func* new_connection;
extern Func* new_connection_contents;
extern Func* connection_attempt;
extern Func* connection_established;
extern Func* partial_connection;
extern Func* connection_partial_close;
extern Func* connection_finished;
extern Func* connection_half_finished;
extern Func* connection_rejected;
extern Func* connection_reset;
extern Func* connection_pending;

extern Func* packet_contents;

extern Func* udp_request;
extern Func* udp_reply;
extern Func* udp_session_done;

extern Func* icmp_sent;
extern Func* icmp_echo_request;
extern Func* icmp_echo_reply;
extern Func* icmp_unreachable;

extern RecordType* net_stats;
extern Func* net_stats_update;
extern Func* conn_stats;

extern int watchdog_interval;
extern double heartbeat_interval;

extern int max_timer_expires;

extern Func* conn_weird;
extern Func* conn_weird_addl;
extern Func* flow_weird;
extern Func* net_weird;
extern Func* rexmit_inconsistency;
extern Func* ack_above_hole;

extern double frag_timeout;

extern int partial_connection_ok;
extern int tcp_SYN_ack_ok;

extern double tcp_SYN_timeout;
extern double tcp_session_timer;
extern double tcp_connection_linger;
extern double tcp_attempt_delay;
extern double tcp_close_delay;
extern double tcp_partial_close_delay;
extern double tcp_reset_delay;

extern double non_analyzed_lifetime;

extern int tcp_storm_thresh;
extern double tcp_storm_interarrival_thresh;

extern double dns_session_timeout;
extern double ntp_session_timeout;
extern double rpc_timeout;

extern Func* inconsistent_option;
extern Func* bad_option;
extern Func* bad_option_termination;

extern Func* finger_request;
extern Func* finger_reply;

extern Func* ident_request;
extern Func* ident_reply;
extern Func* ident_error;

extern ListVal* skip_authentication;
extern ListVal* direct_login_prompts;
extern ListVal* login_prompts;
extern ListVal* login_non_failure_msgs;
extern ListVal* login_failure_msgs;
extern ListVal* login_success_msgs;
extern ListVal* login_timeouts;

extern Func* login_failure;
extern Func* login_success;
extern Func* login_input_line;
extern Func* login_output_line;
extern Func* login_confused;
extern Func* login_confused_text;
extern Func* login_terminal;
extern Func* login_display;
extern Func* excessive_line;

extern Func* authentication_accepted;
extern Func* authentication_rejected;
extern Func* authentication_skipped;

extern Func* activating_encryption;

extern Func* ftp_request;
extern Func* ftp_reply;

extern Func* http_request;
extern Func* http_reply;
extern Func* http_stats;
extern RecordType* http_stats_rec;

extern int pm_request;

extern Func* pm_request_null;
extern Func* pm_request_set;
extern Func* pm_request_unset;
extern Func* pm_request_getport;
extern Func* pm_request_dump;
extern Func* pm_request_callit;

extern Func* pm_attempt_null;
extern Func* pm_attempt_set;
extern Func* pm_attempt_unset;
extern Func* pm_attempt_getport;
extern Func* pm_attempt_dump;
extern Func* pm_attempt_callit;

extern Func* pm_bad_port;

extern RecordType* pm_mapping;
extern TableType* pm_mappings;
extern RecordType* pm_port_request;
extern RecordType* pm_callit_request;

extern RecordType* ntp_msg;
extern Func* ntp_message;

extern RecordType* dns_msg;
extern RecordType* dns_answer;
extern RecordType* dns_soa;

extern Func* dns_request;
extern Func* dns_full_request;

extern Func* dns_A_reply;
extern Func* dns_NS_reply;
extern Func* dns_CNAME_reply;
extern Func* dns_PTR_reply;
extern Func* dns_SOA_reply;
extern Func* dns_WKS_reply;
extern Func* dns_HINFO_reply;
extern Func* dns_MX_reply;
extern Func* dns_TXT_reply;
extern Func* dns_SRV_reply;

extern Func* dns_EDNS0;

extern double stp_delta;
extern double stp_idle_min;

extern Func* stp_create_endp;
extern Func* stp_resume_endp;
extern Func* stp_correlate_pair;
extern Func* stp_remove_pair;
extern Func* stp_remove_endp;

extern double interconn_min_interarrival;
extern double interconn_max_interarrival;
extern int interconn_max_keystroke_pkt_size;
extern int interconn_default_pkt_size;
extern double interconn_stat_period;
extern double interconn_stat_backoff;
extern RecordType* interconn_endp_stats;

extern Func* interconn_remove_conn;
extern Func* interconn_stats;

extern double backdoor_stat_period;
extern double backdoor_stat_backoff;

extern RecordType* backdoor_endp_stats;
extern Func* backdoor_stats;
extern Func* backdoor_remove_conn;
extern Func* rlogin_signature_found;
extern Func* ssh_signature_found;
extern Func* telnet_signature_found;
extern Func* root_backdoor_signature_found;
extern Func* ftp_signature_found;
extern Func* napster_signature_found;
extern Func* gnutella_signature_found;

extern void init_net_var();

#endif
